var carousel = $('#carousel'),
    threshold = 150,
    slideWidth = 500,
    dragStart,
    dragEnd;

$('#next').click(function(){ shiftSlide(-1) })
$('#prev').click(function(){ shiftSlide(1) })

var stlinkInstalled = false;
var driverInstalled = false;

carousel.on('mousedown', function(){
  if (carousel.hasClass('transition')) return;
  dragStart = event.pageX;
  $(this).on('mousemove', function(){
    dragEnd = event.pageX;
    $(this).css('transform','translateX('+ dragPos() +'px)')
  })
  $(document).on('mouseup', function(){
    if (dragPos() > threshold) { return shiftSlide(1) }
    if (dragPos() < -threshold) { return shiftSlide(-1) }
    shiftSlide(0);
  })
});

function dragPos() {
  return dragEnd - dragStart;
}

function shiftSlide(direction) {
  if (carousel.hasClass('transition')) return;
  dragEnd = dragStart;
  $(document).off('mouseup')
  carousel.off('mousemove')
          .addClass('transition')
          .css('transform','translateX(' + (direction * slideWidth) + 'px)');
  setTimeout(function(){
    if (direction === 1) {
      $('.slide:first').before($('.slide:last'));
    } else if (direction === -1) {
      $('.slide:last').after($('.slide:first'));
    }
    carousel.removeClass('transition')
		carousel.css('transform','translateX(0px)');
  },700)
}

$(function(){
    $( "#dialog" ).dialog({
        autoOpen: false,
        show: {
        effect: "fade",
        duration: 250
        },
        hide: {
        effect: "fade",
        duration: 250
        }
    });

    $( "#osxDialog" ).dialog({
        autoOpen: false,
        show: {
        effect: "fade",
        duration: 250
        },
        hide: {
        effect: "fade",
        duration: 250
        }
    });

    $( "#windowsDialog" ).dialog({
        autoOpen: false,
        show: {
        effect: "fade",
        duration: 250
        },
        hide: {
        effect: "fade",
        duration: 250
        },
        buttons: {
        No: function() {
          $( this ).dialog( "close" );
        },
        Yes: function() {
          $( this ).dialog( "close" );
          $( "#windowsDialog2" ).dialog( "open" );
          eel.install_drivers()
        }
      }
    });

    $( "#windowsDialog2" ).dialog({
        autoOpen: false,
        show: {
        effect: "fade",
        duration: 250
        },
        hide: {
        effect: "fade",
        duration: 250
        },
        buttons: {
        Ok: function() {
          $( this ).dialog( "close" );
        }
      }
    });

    $('#status').html('Follow the instructions above, then click "UPDATE"...');

    eel.check_drivers()

    eel.check_stlink()((stlinkStatus) =>{
        console.log("stlinkStatus", stlinkStatus);
        if(!stlinkStatus){
            stlinkInstalled = true;
        }
    })



});


$('#selectPort').click(function(){
    console.log("select ports...")
    eel.list_ports()((ports) => {
        console.log(ports);

        var select = $('<select>');

        select.addClass("comPortSelect");

        select.change(function(){
                var $option = $(this).find('option:selected');
                var value = $option.val();
                var text = $option.text();

                console.log(value, text);

                $('#status').html('Port: ' + value);
                $( "#dialog" ).dialog( "close" );

            });

        select.append($('<option>').prop('value', 'null').text("null"));

        $.each(ports, function(index, port){
            console.log(port);
            select.append($('<option>').prop('value', port).text(port.replace("/dev/", "").replace("cu.", "").replace("tty.", "")));
        })

        var container = $('#comPortSelect');
        container.empty();
        container.append(select);
        $( "#dialog" ).dialog( "open" );
    })
})

var updateStatus = function(arg){
    $('#status').html(arg);
}

var currentState = 'idle';
var nextState = 'idle';
var ticks = 0;

var updateIndex = 0;

var uploadIndex = 0;

var setNextState = function(nState){
    nextState = nState;
    setTimeout(update,0)
}

var getNextState = function(){
    return nextState;
}

var setCurrentState = function(nState){
    currentState = nState;
}

var getCurrentState = function(){
    return currentState;
}


var flashTimeout = null;

var update = function(){
    console.log("update",updateIndex++,  getCurrentState(), getNextState());

    if(getCurrentState() !== getNextState()){
        console.log(getCurrentState(), " => ", getNextState())
        switch(getNextState()){

        }

        setCurrentState(getNextState());
    }

    switch(getCurrentState()){
        case 'idle':
            updateIndex = 0;
            if(flashTimeout){
                clearTimeout(flashTimeout);
                flashTimeout = null;
            }
        break;
        case 'start':
            eel.st_ping()((s) => {
                if(s.indexOf('UNEXPECTED idcode') >= 0){
                    updateStatus("Beacon found!, starting update.")
                    setNextState('getFirmware')
                }else if(s.indexOf('init mode failed') >= 0){
                    updateStatus("Beacon not found, please plug in the programming adapter to the Beacon and wake it up. (knock it or power cycle it)")
                    setNextState('idle')
                }else{
                    updateStatus("Adapter not found, please plug in the programming adapter to the computer.")
                    setNextState('idle')
                }
            });
        break;
        case 'getFirmware':
            updateStatus("Connecting to Soiltech update server.");
            console.log("getFirmware loop")
            eel.get_firmware()((s) => {
                console.log("getFirmware", s);
                if(s){
                    setNextState('flashBeacon')
                }else{
                    setNextState('flashPotato')
                }

            });
        break;
        case 'flashBeacon':
            console.log("flashBeacon loop")
            eel.begin_flash(false);

        break;
        case 'flashPotato':
            console.log("flashPotato loop")
            eel.begin_flash(true);

        break;

    }

}

var mySelf = this;

var flashTimeout = null;

$('#update').click(function(){

    if(updateIndex == 0)
    {

        flashTimeout = setTimeout(()=>{
            console.log("flashTimeout")
            setNextState('idle');
        },60000)

        setNextState('start');
    }


})

$('#update2').click(function(){

    if(updateIndex == 0)
    {

        flashTimeout = setTimeout(()=>{
            console.log("flashTimeout")
            setNextState('idle');
        },60000)

        setNextState('start');
    }


})

function driver_status_cb(driverStatus){
    console.log("driverStatus", driverStatus);
    driverInstalled = driverStatus;
    if(!driverInstalled){
        $( "#windowsDialog" ).dialog( "open" );
    }
}

var progress = '|'

function flash_status_cb(status){
    var tokens = status.split(" ")
    if(tokens.length >= 3){
        updateIndex++;
        if(updateIndex % 100 == 0){

            console.log(tokens[1], getCurrentState())
            progress += '|'
            updateStatus("Updating Beacon: " + progress);

            if(progress.length >= 65)
            {
                progress = '|'
            }
        }

        if(tokens.indexOf('stlink_usb_exit_mode():') >= 0  && parseInt(tokens[1]) > 2000){

            setTimeout(function(){
                console.log("Update was successful")
                updateStatus("Update finished! ("+ (getCurrentState() == 'flashPotato' ? "D" : "C") +")");
                setNextState('idle');
            },1000);

        }else if((tokens.indexOf('init') >= 0 && tokens.indexOf('mode') >= 0 && tokens.indexOf('failed') >= 0) ||
            (tokens.indexOf('failed') >= 0 && tokens.indexOf('with') >= 0 && tokens.indexOf('error') >= 0)){

            setTimeout(function(){
                console.log("Beacon not found")
                updateStatus("Beacon not found, please plug in the programming adapter to the Beacon and wake it up. (knock it or power cycle it)")
                setNextState('idle')
            },1000)
        }
    }

}

eel.expose(flash_status_cb);
eel.expose(driver_status_cb);

